from decimal import Decimal


# TODO Метод левых прямоугольников
def left_rectangle_method(fx: callable, a,  b, steps: int) -> float:
    w = (b - a) / steps
    return sum(fx(x) * w for x in range(a, b, w))


# TODO Метод правых прямоугольников
def right_rectangle_method(fx: callable, a,  b, steps: int) -> float:
    w = (b - a) / steps
    return sum(fx(x) * w for x in range(a + w, b + w, w))


# TODO Метод трапеций
def trapezium_method(fx: callable, a: Decimal, b: Decimal, steps: int) -> Decimal:
    w: Decimal = (b - a) / steps
    x1 = a
    res = Decimal(0)

    for x in range(a + w, b + w, w):
        y = fx((x1 + x) / 2)
        x1 = x
        res += y

    return res


# TODO Метод парабол
def parabola_method(fx: callable, a: Decimal, b: Decimal, steps: int) -> Decimal:
    pass


# TODO Метод переменного шага: Двойной пересчет
def double_count_method(fx: callable, a: Decimal, b: Decimal, steps: int) -> Decimal:
    pass


# TODO Метод переменного шага: Некий секретный алгоритм
def mysterious_method(fx: callable, a: Decimal, b: Decimal, steps: int) -> Decimal:
    pass
